#ifndef STREAMPARSER_H
#define STREAMPARSER_H

#include <QDomDocument>
#include <QXmlStreamReader>
#include <utils/xmpperror.h>

class StreamParser :
	public QObject
{
	Q_OBJECT;
public:
	StreamParser(QObject *AParent = NULL);
	~StreamParser();
	void parseData(const QByteArray &AData);
	void restart();
signals:
	void opened(const QDomElement &AElem);
	void element(const QDomElement &AElem);
	void error(const XmppError &AError);
	void closed();
private:
	int FLevel;
	QDomText FElemSpace;
	QDomElement FStanzaElem;
	QDomElement FCurrentElem;
	QXmlStreamReader FReader;
};

#endif // STREAMPARSER_H
